;X=r3 bank 2
;Y=r4 bank 2
;no timer@counter
countY:
		mov		a,#0C7H
		call	LCD_command
		mov   	dptr,#my_string18    ;display Y=?     
		call   LCD_sendstring 	    ;Send data
		mov		15h,#0C9H	 		;
		call	get_key2
swap_noY:		
		swap	a				;swap lower nib with high nib
		mov		41H,a
		mov		15h,#0CAH

		call	get_key2   ;get 2nd input for X

loadY:	
		mov		r1,#41H
    	xchd	a,@r1		;xchange low nibble of each operand
		xch		a,@r1
		mov		41h,a
		mov		42h,a			;save X number to r4 bank 2
		ret

countX:	

		mov   	dptr,#my_string17     ;X=?    
		call   LCD_sendstring 	    ;Send data
		mov		15h,#0C2H		  ;r5 bnk 2
		call	get_key2
swap_noX:		
		swap	a			;swap lower nib with high nib
		mov		40H,a
		mov		15h,#0C3H
		call	get_key2   ;get 2nd input for X

loadX:	
		mov		r0,#40H
    	xchd	a,@r0		;xchange low nibble of each operand
		xch		a,@r0
		mov		40h,a			;save X number to r3 bank 2
		ret	
get_key2:
;------------row1-------------------
rowa1:
        mov 	keyport,#0EFH       ;make Row1 low
		jb		col1,nextcola
		jnb		col1,$
		mov		a,15h
		call	LCD_command
		mov		a,#'1'
		call 	LCD_senddata	
		mov		a,#1
		ret
nextcola:
		jb	col2,nextcola1
		jnb	col2,$
		mov	a,15h
		call	LCD_command
		mov	a,#'2'
		call 	LCD_senddata	
		mov	a,#2
		ret
nextcola1:
		jb	col3,nextcola11
		jnb	col3,$
		mov	a,15h
		call	LCD_command
		mov	a,#'3'
		call 	LCD_senddata	
		mov	a,#3
		ret
nextcola11:
/*		jb	col4,rowa2
		jnb	col4,$
		jmp	not_exec	
*/		jb	col4,rowa2
		jnb	col4,$
		mov	a,15h
		call	LCD_command
		mov	a,#'A'
		call 	LCD_senddata	
		mov	a,#0Ah
		ret
;------------------row2--------------------        
rowa2:
        mov keyport,#0DFH       ;make Row2 low
		jb	col1,nextcola2		
		jnb	col1,$
		mov	a,15h
		call	LCD_command
		mov	a,#'4'
		call 	LCD_senddata	
		mov	a,#4
		ret
nextcola2:
		jb	col2,nextcola22		
		jnb	col2,$
		mov	a,15h
		call	LCD_command
		mov	a,#'5'
		call 	LCD_senddata	
		mov	a,#5
		ret
nextcola22:
		jb	col3,nextcola222		;
		jnb	col3,$
		mov	a,15h
		call	LCD_command
		mov	a,#'6'
		call 	LCD_senddata	
		mov	a,#6	
		ret	
nextcola222:
/*		jb	col4,rowa3		
		jnb	col4,$
		jmp	not_exec	
*/		jb	col4,rowa3		;
		jnb	col4,$
		mov	a,15h
		call	LCD_command
		mov	a,#'B'
		call 	LCD_senddata	
		mov	a,#0Bh	
		ret
;-------------row3--------------------------------
rowa3:
        mov keyport,#0BFH       ;make row3 low
		jb	col1,nextcola3		
		jnb	col1,$
		mov	a,15h
		call	LCD_command
		mov	a,#'7'
		call 	LCD_senddata	
		mov	a,#7	
		ret
		
nextcola3:
		jb	col2,nextcola33		
		jnb	col2,$
		mov	a,15h
		call	LCD_command
		mov	a,#'8'
		call 	LCD_senddata	
		mov	a,#8	
		ret
		
nextcola33:
		jb	col3,nextcola333		
		jnb	col3,$
		mov	a,15h
		call	LCD_command
		mov	a,#'9'
		call 	LCD_senddata	
		mov	a,#9	
		ret
	
nextcola333:
/*		jb	col4,rowa4		
		jnb	col4,$
		jmp	not_exec	
*/		jb	col4,rowa4		
		jnb	col4,$
		mov	a,15h
		call	LCD_command
		mov	a,#'C'
		call 	LCD_senddata	
		mov	a,#0Ch	
		ret
;----------row4--------------------
rowa4:
        mov keyport,#07FH       ;make row4 low
/*		jb	col1,nextcola4		
		jnb	col1,$
		jmp	not_exec	
*/		jb	col1,nextcola4		
		jnb	col1,$
		mov	a,15h
		call	LCD_command
		mov	a,#'F'
		call 	LCD_senddata	
		mov	a,#0Fh	
		ret
nextcola4:
		jb	col2,nextcola44		
		jnb	col2,$
		mov	a,15h
		call	LCD_command
		mov	a,#'0'
		call 	LCD_senddata	
		mov	a,#0h	
		ret
nextcola44:
/*		jb	col3,nextcola444		
		jnb	col3,$
		jmp	not_exec	
*/		jb	col3,nextcola444		
		jnb	col3,$
		mov	a,15h
		call	LCD_command
		mov	a,#'E'
		call 	LCD_senddata	
		mov	a,#0Eh	
		ret
nextcola444:
/*		jb	col4,not_done		
		jnb	col4,$
		jmp	not_exec		
*/		jb	col4,cancel		
		jnb	col4,$
		mov	a,15h
		call	LCD_command
		mov	a,#'D'
		call 	LCD_senddata	
		mov	a,#0Dh	
		ret

cancel:
		jb	sw2,not_done
		jnb	sw2,$
		mov   a,#01H         ;clear LCD
		call LCD_command 
		jmp	again2
/*
not_exec:
		mov   	a,#01H         		;01H is command for clearing LCD
		lcall 	LCD_command    		;Send the command
		mov   	dptr,#my_string19         
		lcall   LCD_sendstring   	;Send data
		mov   	a,#01H         		;01H is command for clearing LCD
		lcall 	LCD_command    		;Send the command

		ljmp	again
*/		
not_done:	
		jmp	rowa1

;-----------------show_count------------------------
;use for ENDURANCE loop counting
;X=r3
;Y=r4

count_start:
		setb	28h
		mov   a,#0C0H         
		acall LCD_command    
		mov   dptr,#my_string19   
		acall LCD_sendstring    
decra:
		mov		r0,#41h
		mov		@r0,42h				 ;mov value at 42h RAM to 41h RAM
decre2:	
		call	write38k			 ;jump to status96
		cjne	r7,#90H,stop
		call	checksum38k
		cjne	r7,#6EH,stop   ;add
		call 	short_delay
		nop
		nop
		call	erase38k	   	
		cjne	r7,#90h,stop		 ;jump to status96
		call	checksum38k
		cjne	r7,#21h,stop   ;add
		call 	short_delay
;count_again:
		djnz	41h,decre2			 ;42h,decre2
		djnz	40h,decra			 ;46h,decra
		mov   a,#0C0H         
		call LCD_command    ;Send the command
		mov   	dptr,#my_string23         
		call LCD_sendstring   ;Send data SUCCESS
		clr		28h		;clear back to show 9000 status
		ret
stop:
		clr		xOK
		mov  	 a,#01H         	;01H is command for clearing LCD
		call 	LCD_command
		mov  	 a,#0C0H         	
		call 	LCD_command
		mov   	dptr,#my_string20         
		call 	LCD_sendstring
		mov  	 a,#0C6H         	
		call 	LCD_command

show_count:
		mov		r6,#1		  ;just return back
		mov		a,40h		  ;show remaining X number
		call	ATR_bytes	  ;to show 1st count
		mov		r6,#1		  ;just return back
		mov		a,41h		  ;show remaining Y number
		call	ATR_bytes	  ;to show 2nd count
		jmp	again


short_delay:		   
	mov r7,#100			;PREVIOUS 99
load_delay:
	mov r6,#17			;previous 20
short_delay1:
	djnz r6,short_delay1
	djnz r7,load_delay
	ret